package com.keyboard.keyboardtheme.skin

//import com.pretty.keyboard.theme.keyboard.helper.ObjectBox
import android.app.Application
import android.graphics.Typeface
import com.ad.toponlibrary.AdManager
import com.keyboard.keyboardtheme.skin.datamanager.localdata.Child
import com.keyboard.keyboardtheme.skin.datamanager.localdata.ParentData
import com.up.uploadlibrary.UpLoadManager
import org.json.JSONArray
import java.io.BufferedReader
import java.io.IOException
import java.io.InputStream
import java.io.InputStreamReader
import java.io.StringWriter


class MyApp : Application() {
    companion object {
        lateinit var myAppInstance: MyApp

        lateinit var list: List<ParentData>

        const val TAG = "-----------------"
        var defaultFont: Typeface? = null
        const val DB_VERSION = 1
        const val DB_NAME = "db_name"
    }

    override fun onCreate() {
        super.onCreate()
        myAppInstance = this
        defaultFont = Typeface.createFromAsset(assets, "font5.ttf")
        dealFile()
        AdManager.init(TAG,this,"h68944103435d2","a41be189d623537d941b78e1f704b79be",
            "9788519403e27aa6420a9b9ad49bc0fc76166bea",
            "n6894416554630",
            "n689441559c5ff",
            "n68944149bda5b",false);
        UpLoadManager.init(this,TAG);

    }

    private fun dealFile() {
        val openFile = myAppInstance.assets.open("data.json")
        val jsonString = getJsonString(openFile)
        if (jsonString != null) {
            resolveJsonString(jsonString)
        }
    }


    private fun resolveJsonString(string: String) {
        val jsonData = JSONArray(string)
        var dataList: MutableList<ParentData> = mutableListOf()
        for (i in 0 until jsonData.length()) {
            jsonData.getJSONObject(i).run {
                val pName = getString("parent_name")
                val listArray = getJSONArray("keyboard_list")
                var childList: MutableList<Child> = mutableListOf()
                for (listIndex in 0 until listArray.length()) {
                    listArray.getJSONObject(listIndex).also {
                        val title = it.getString("title")
                        val thUrl = it.getString("thumbUrl")
                        val thGif = it.getString("thumbUrlGif")
                        var zipPath = ""
                        var imgPath = ""
                        var imgGif = ""
                        var imgPreviewGif = ""
                        if (it.has("detail")) {
                            val contentObject =
                                it.getJSONObject("detail").getJSONObject("themeContent")
                            zipPath = contentObject.getString("androidRawZipUrl")
                            imgPath = contentObject.getString("img")
                            imgGif = contentObject.getString("imgGif")
                            imgPreviewGif = contentObject.getString("imgPreviewGif")
                        } else {

                        }
                        childList.add(
                            Child()
                                .apply {
                            setImgPath(imgPath)
                            setZipPath(zipPath)
                            setTitleName(title)
                            setImgGif(imgGif)
                            thumbUrl = thUrl
                            thumbGif = thGif
                        })

                    }

                }
                val shuffled = childList.shuffled()
                val dataParentData = ParentData()
                    .apply {
                    parentName = pName
                    keyboardList = shuffled
                }
                dataList.add(dataParentData)

            }
        }

        updateDataList(dataList)

    }

    private fun updateDataList(mainList: MutableList<ParentData>) {

        list = mainList.shuffled()

    }
    private fun getJsonString(fileInputStream: InputStream): String? {
        return try {
            val charArray = CharArray(fileInputStream.available())
            var readCount = 0
            val streamReader = InputStreamReader(fileInputStream)
            val bufferedReader = BufferedReader(streamReader)
            val stringWriter = StringWriter()
            while (bufferedReader.read(charArray).also { readCount = it } != -1) {
                stringWriter.write(charArray, 0, readCount)
            }
            stringWriter.toString()
        } catch (e: IOException) {
            ""
        }
    }





}